package io.fabric8.openshift.api.model;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class CustomTLSProfileBuilder extends io.fabric8.openshift.api.model.CustomTLSProfileFluentImpl<io.fabric8.openshift.api.model.CustomTLSProfileBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.openshift.api.model.CustomTLSProfile,io.fabric8.openshift.api.model.CustomTLSProfileBuilder>{
  public CustomTLSProfileBuilder() {
    this(false);
  }
  public CustomTLSProfileBuilder(java.lang.Boolean validationEnabled) {
    this(new CustomTLSProfile(), validationEnabled);
  }
  public CustomTLSProfileBuilder(io.fabric8.openshift.api.model.CustomTLSProfileFluent<?> fluent) {
    this(fluent, false);
  }
  public CustomTLSProfileBuilder(io.fabric8.openshift.api.model.CustomTLSProfileFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new CustomTLSProfile(), validationEnabled);
  }
  public CustomTLSProfileBuilder(io.fabric8.openshift.api.model.CustomTLSProfileFluent<?> fluent,io.fabric8.openshift.api.model.CustomTLSProfile instance) {
    this(fluent, instance, false);
  }
  public CustomTLSProfileBuilder(io.fabric8.openshift.api.model.CustomTLSProfileFluent<?> fluent,io.fabric8.openshift.api.model.CustomTLSProfile instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withCiphers(instance.getCiphers()); 
    fluent.withMinTLSVersion(instance.getMinTLSVersion()); 
    this.validationEnabled = validationEnabled; 
  }
  public CustomTLSProfileBuilder(io.fabric8.openshift.api.model.CustomTLSProfile instance) {
    this(instance,false);
  }
  public CustomTLSProfileBuilder(io.fabric8.openshift.api.model.CustomTLSProfile instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withCiphers(instance.getCiphers()); 
    this.withMinTLSVersion(instance.getMinTLSVersion()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.openshift.api.model.CustomTLSProfileFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.openshift.api.model.CustomTLSProfile build() {
    CustomTLSProfile buildable = new CustomTLSProfile(fluent.getCiphers(),fluent.getMinTLSVersion());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    CustomTLSProfileBuilder that = (CustomTLSProfileBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}