package io.fabric8.openshift.api.model;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class TLSSecurityProfileBuilder extends io.fabric8.openshift.api.model.TLSSecurityProfileFluentImpl<io.fabric8.openshift.api.model.TLSSecurityProfileBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.openshift.api.model.TLSSecurityProfile,io.fabric8.openshift.api.model.TLSSecurityProfileBuilder>{
  public TLSSecurityProfileBuilder() {
    this(false);
  }
  public TLSSecurityProfileBuilder(java.lang.Boolean validationEnabled) {
    this(new TLSSecurityProfile(), validationEnabled);
  }
  public TLSSecurityProfileBuilder(io.fabric8.openshift.api.model.TLSSecurityProfileFluent<?> fluent) {
    this(fluent, false);
  }
  public TLSSecurityProfileBuilder(io.fabric8.openshift.api.model.TLSSecurityProfileFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new TLSSecurityProfile(), validationEnabled);
  }
  public TLSSecurityProfileBuilder(io.fabric8.openshift.api.model.TLSSecurityProfileFluent<?> fluent,io.fabric8.openshift.api.model.TLSSecurityProfile instance) {
    this(fluent, instance, false);
  }
  public TLSSecurityProfileBuilder(io.fabric8.openshift.api.model.TLSSecurityProfileFluent<?> fluent,io.fabric8.openshift.api.model.TLSSecurityProfile instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withCustom(instance.getCustom()); 
    fluent.withIntermediate(instance.getIntermediate()); 
    fluent.withModern(instance.getModern()); 
    fluent.withOld(instance.getOld()); 
    fluent.withType(instance.getType()); 
    this.validationEnabled = validationEnabled; 
  }
  public TLSSecurityProfileBuilder(io.fabric8.openshift.api.model.TLSSecurityProfile instance) {
    this(instance,false);
  }
  public TLSSecurityProfileBuilder(io.fabric8.openshift.api.model.TLSSecurityProfile instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withCustom(instance.getCustom()); 
    this.withIntermediate(instance.getIntermediate()); 
    this.withModern(instance.getModern()); 
    this.withOld(instance.getOld()); 
    this.withType(instance.getType()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.openshift.api.model.TLSSecurityProfileFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.openshift.api.model.TLSSecurityProfile build() {
    TLSSecurityProfile buildable = new TLSSecurityProfile(fluent.getCustom(),fluent.getIntermediate(),fluent.getModern(),fluent.getOld(),fluent.getType());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    TLSSecurityProfileBuilder that = (TLSSecurityProfileBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}