package io.fabric8.openshift.api.model.operator.v1;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class AuthenticationSpecBuilder extends io.fabric8.openshift.api.model.operator.v1.AuthenticationSpecFluentImpl<io.fabric8.openshift.api.model.operator.v1.AuthenticationSpecBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.openshift.api.model.operator.v1.AuthenticationSpec,io.fabric8.openshift.api.model.operator.v1.AuthenticationSpecBuilder>{
  public AuthenticationSpecBuilder() {
    this(false);
  }
  public AuthenticationSpecBuilder(java.lang.Boolean validationEnabled) {
    this(new AuthenticationSpec(), validationEnabled);
  }
  public AuthenticationSpecBuilder(io.fabric8.openshift.api.model.operator.v1.AuthenticationSpecFluent<?> fluent) {
    this(fluent, false);
  }
  public AuthenticationSpecBuilder(io.fabric8.openshift.api.model.operator.v1.AuthenticationSpecFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new AuthenticationSpec(), validationEnabled);
  }
  public AuthenticationSpecBuilder(io.fabric8.openshift.api.model.operator.v1.AuthenticationSpecFluent<?> fluent,io.fabric8.openshift.api.model.operator.v1.AuthenticationSpec instance) {
    this(fluent, instance, false);
  }
  public AuthenticationSpecBuilder(io.fabric8.openshift.api.model.operator.v1.AuthenticationSpecFluent<?> fluent,io.fabric8.openshift.api.model.operator.v1.AuthenticationSpec instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withLogLevel(instance.getLogLevel()); 
    fluent.withManagementState(instance.getManagementState()); 
    fluent.withObservedConfig(instance.getObservedConfig()); 
    fluent.withOperatorLogLevel(instance.getOperatorLogLevel()); 
    fluent.withUnsupportedConfigOverrides(instance.getUnsupportedConfigOverrides()); 
    this.validationEnabled = validationEnabled; 
  }
  public AuthenticationSpecBuilder(io.fabric8.openshift.api.model.operator.v1.AuthenticationSpec instance) {
    this(instance,false);
  }
  public AuthenticationSpecBuilder(io.fabric8.openshift.api.model.operator.v1.AuthenticationSpec instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withLogLevel(instance.getLogLevel()); 
    this.withManagementState(instance.getManagementState()); 
    this.withObservedConfig(instance.getObservedConfig()); 
    this.withOperatorLogLevel(instance.getOperatorLogLevel()); 
    this.withUnsupportedConfigOverrides(instance.getUnsupportedConfigOverrides()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.openshift.api.model.operator.v1.AuthenticationSpecFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.openshift.api.model.operator.v1.AuthenticationSpec build() {
    AuthenticationSpec buildable = new AuthenticationSpec(fluent.getLogLevel(),fluent.getManagementState(),fluent.getObservedConfig(),fluent.getOperatorLogLevel(),fluent.getUnsupportedConfigOverrides());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    AuthenticationSpecBuilder that = (AuthenticationSpecBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}