package io.fabric8.openshift.api.model.operator.v1;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class ConsoleSpecBuilder extends io.fabric8.openshift.api.model.operator.v1.ConsoleSpecFluentImpl<io.fabric8.openshift.api.model.operator.v1.ConsoleSpecBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.openshift.api.model.operator.v1.ConsoleSpec,io.fabric8.openshift.api.model.operator.v1.ConsoleSpecBuilder>{
  public ConsoleSpecBuilder() {
    this(false);
  }
  public ConsoleSpecBuilder(java.lang.Boolean validationEnabled) {
    this(new ConsoleSpec(), validationEnabled);
  }
  public ConsoleSpecBuilder(io.fabric8.openshift.api.model.operator.v1.ConsoleSpecFluent<?> fluent) {
    this(fluent, false);
  }
  public ConsoleSpecBuilder(io.fabric8.openshift.api.model.operator.v1.ConsoleSpecFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new ConsoleSpec(), validationEnabled);
  }
  public ConsoleSpecBuilder(io.fabric8.openshift.api.model.operator.v1.ConsoleSpecFluent<?> fluent,io.fabric8.openshift.api.model.operator.v1.ConsoleSpec instance) {
    this(fluent, instance, false);
  }
  public ConsoleSpecBuilder(io.fabric8.openshift.api.model.operator.v1.ConsoleSpecFluent<?> fluent,io.fabric8.openshift.api.model.operator.v1.ConsoleSpec instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withCustomization(instance.getCustomization()); 
    fluent.withLogLevel(instance.getLogLevel()); 
    fluent.withManagementState(instance.getManagementState()); 
    fluent.withObservedConfig(instance.getObservedConfig()); 
    fluent.withOperatorLogLevel(instance.getOperatorLogLevel()); 
    fluent.withPlugins(instance.getPlugins()); 
    fluent.withProviders(instance.getProviders()); 
    fluent.withRoute(instance.getRoute()); 
    fluent.withUnsupportedConfigOverrides(instance.getUnsupportedConfigOverrides()); 
    this.validationEnabled = validationEnabled; 
  }
  public ConsoleSpecBuilder(io.fabric8.openshift.api.model.operator.v1.ConsoleSpec instance) {
    this(instance,false);
  }
  public ConsoleSpecBuilder(io.fabric8.openshift.api.model.operator.v1.ConsoleSpec instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withCustomization(instance.getCustomization()); 
    this.withLogLevel(instance.getLogLevel()); 
    this.withManagementState(instance.getManagementState()); 
    this.withObservedConfig(instance.getObservedConfig()); 
    this.withOperatorLogLevel(instance.getOperatorLogLevel()); 
    this.withPlugins(instance.getPlugins()); 
    this.withProviders(instance.getProviders()); 
    this.withRoute(instance.getRoute()); 
    this.withUnsupportedConfigOverrides(instance.getUnsupportedConfigOverrides()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.openshift.api.model.operator.v1.ConsoleSpecFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.openshift.api.model.operator.v1.ConsoleSpec build() {
    ConsoleSpec buildable = new ConsoleSpec(fluent.getCustomization(),fluent.getLogLevel(),fluent.getManagementState(),fluent.getObservedConfig(),fluent.getOperatorLogLevel(),fluent.getPlugins(),fluent.getProviders(),fluent.getRoute(),fluent.getUnsupportedConfigOverrides());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    ConsoleSpecBuilder that = (ConsoleSpecBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}