package io.fabric8.openshift.api.model.operator.v1;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class DNSBuilder extends io.fabric8.openshift.api.model.operator.v1.DNSFluentImpl<io.fabric8.openshift.api.model.operator.v1.DNSBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.openshift.api.model.operator.v1.DNS,io.fabric8.openshift.api.model.operator.v1.DNSBuilder>{
  public DNSBuilder() {
    this(false);
  }
  public DNSBuilder(java.lang.Boolean validationEnabled) {
    this(new DNS(), validationEnabled);
  }
  public DNSBuilder(io.fabric8.openshift.api.model.operator.v1.DNSFluent<?> fluent) {
    this(fluent, false);
  }
  public DNSBuilder(io.fabric8.openshift.api.model.operator.v1.DNSFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new DNS(), validationEnabled);
  }
  public DNSBuilder(io.fabric8.openshift.api.model.operator.v1.DNSFluent<?> fluent,io.fabric8.openshift.api.model.operator.v1.DNS instance) {
    this(fluent, instance, false);
  }
  public DNSBuilder(io.fabric8.openshift.api.model.operator.v1.DNSFluent<?> fluent,io.fabric8.openshift.api.model.operator.v1.DNS instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withApiVersion(instance.getApiVersion()); 
    fluent.withKind(instance.getKind()); 
    fluent.withMetadata(instance.getMetadata()); 
    fluent.withSpec(instance.getSpec()); 
    fluent.withStatus(instance.getStatus()); 
    this.validationEnabled = validationEnabled; 
  }
  public DNSBuilder(io.fabric8.openshift.api.model.operator.v1.DNS instance) {
    this(instance,false);
  }
  public DNSBuilder(io.fabric8.openshift.api.model.operator.v1.DNS instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withApiVersion(instance.getApiVersion()); 
    this.withKind(instance.getKind()); 
    this.withMetadata(instance.getMetadata()); 
    this.withSpec(instance.getSpec()); 
    this.withStatus(instance.getStatus()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.openshift.api.model.operator.v1.DNSFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.openshift.api.model.operator.v1.DNS build() {
    DNS buildable = new DNS(fluent.getApiVersion(),fluent.getKind(),fluent.getMetadata(),fluent.getSpec(),fluent.getStatus());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    DNSBuilder that = (DNSBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}