package io.fabric8.openshift.api.model.operator.v1;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class DNSNodePlacementBuilder extends io.fabric8.openshift.api.model.operator.v1.DNSNodePlacementFluentImpl<io.fabric8.openshift.api.model.operator.v1.DNSNodePlacementBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.openshift.api.model.operator.v1.DNSNodePlacement,io.fabric8.openshift.api.model.operator.v1.DNSNodePlacementBuilder>{
  public DNSNodePlacementBuilder() {
    this(false);
  }
  public DNSNodePlacementBuilder(java.lang.Boolean validationEnabled) {
    this(new DNSNodePlacement(), validationEnabled);
  }
  public DNSNodePlacementBuilder(io.fabric8.openshift.api.model.operator.v1.DNSNodePlacementFluent<?> fluent) {
    this(fluent, false);
  }
  public DNSNodePlacementBuilder(io.fabric8.openshift.api.model.operator.v1.DNSNodePlacementFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new DNSNodePlacement(), validationEnabled);
  }
  public DNSNodePlacementBuilder(io.fabric8.openshift.api.model.operator.v1.DNSNodePlacementFluent<?> fluent,io.fabric8.openshift.api.model.operator.v1.DNSNodePlacement instance) {
    this(fluent, instance, false);
  }
  public DNSNodePlacementBuilder(io.fabric8.openshift.api.model.operator.v1.DNSNodePlacementFluent<?> fluent,io.fabric8.openshift.api.model.operator.v1.DNSNodePlacement instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withNodeSelector(instance.getNodeSelector()); 
    fluent.withTolerations(instance.getTolerations()); 
    this.validationEnabled = validationEnabled; 
  }
  public DNSNodePlacementBuilder(io.fabric8.openshift.api.model.operator.v1.DNSNodePlacement instance) {
    this(instance,false);
  }
  public DNSNodePlacementBuilder(io.fabric8.openshift.api.model.operator.v1.DNSNodePlacement instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withNodeSelector(instance.getNodeSelector()); 
    this.withTolerations(instance.getTolerations()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.openshift.api.model.operator.v1.DNSNodePlacementFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.openshift.api.model.operator.v1.DNSNodePlacement build() {
    DNSNodePlacement buildable = new DNSNodePlacement(fluent.getNodeSelector(),fluent.getTolerations());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    DNSNodePlacementBuilder that = (DNSNodePlacementBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}