package io.fabric8.openshift.api.model.operator.v1;

import java.util.ArrayList;
import java.lang.String;
import java.util.function.Predicate;
import java.lang.Integer;
import java.lang.Deprecated;
import io.fabric8.kubernetes.api.builder.BaseFluent;
import java.lang.Long;
import java.util.Collection;
import java.lang.Object;
import java.util.List;
import java.lang.Boolean;

 /**
  * Generated
  */
public class DNSRecordSpecFluentImpl<A extends io.fabric8.openshift.api.model.operator.v1.DNSRecordSpecFluent<A>> extends io.fabric8.kubernetes.api.builder.BaseFluent<A> implements io.fabric8.openshift.api.model.operator.v1.DNSRecordSpecFluent<A>{
  public DNSRecordSpecFluentImpl() {
  }
  public DNSRecordSpecFluentImpl(io.fabric8.openshift.api.model.operator.v1.DNSRecordSpec instance) {
    this.withDnsName(instance.getDnsName()); 
    this.withRecordTTL(instance.getRecordTTL()); 
    this.withRecordType(instance.getRecordType()); 
    this.withTargets(instance.getTargets()); 
  }
  private java.lang.String dnsName;
  private java.lang.Long recordTTL;
  private java.lang.String recordType;
  private java.util.List<java.lang.String> targets = new java.util.ArrayList<java.lang.String>();
  public java.lang.String getDnsName() {
    return this.dnsName;
  }
  public A withDnsName(java.lang.String dnsName) {
    this.dnsName=dnsName; return (A) this;
  }
  public java.lang.Boolean hasDnsName() {
    return this.dnsName != null;
  }
  
  /**
   * Method is deprecated. use withDnsName instead.
   */
  @java.lang.Deprecated
  public A withNewDnsName(java.lang.String arg0) {
    return (A)withDnsName(new String(arg0));
  }
  public java.lang.Long getRecordTTL() {
    return this.recordTTL;
  }
  public A withRecordTTL(java.lang.Long recordTTL) {
    this.recordTTL=recordTTL; return (A) this;
  }
  public java.lang.Boolean hasRecordTTL() {
    return this.recordTTL != null;
  }
  public java.lang.String getRecordType() {
    return this.recordType;
  }
  public A withRecordType(java.lang.String recordType) {
    this.recordType=recordType; return (A) this;
  }
  public java.lang.Boolean hasRecordType() {
    return this.recordType != null;
  }
  
  /**
   * Method is deprecated. use withRecordType instead.
   */
  @java.lang.Deprecated
  public A withNewRecordType(java.lang.String arg0) {
    return (A)withRecordType(new String(arg0));
  }
  public A addToTargets(java.lang.Integer index,java.lang.String item) {
    if (this.targets == null) {this.targets = new java.util.ArrayList<java.lang.String>();}
    this.targets.add(index, item);
    return (A)this;
  }
  public A setToTargets(java.lang.Integer index,java.lang.String item) {
    if (this.targets == null) {this.targets = new java.util.ArrayList<java.lang.String>();}
    this.targets.set(index, item); return (A)this;
  }
  public A addToTargets(java.lang.String... items) {
    if (this.targets == null) {this.targets = new java.util.ArrayList<java.lang.String>();}
    for (java.lang.String item : items) {this.targets.add(item);} return (A)this;
  }
  public A addAllToTargets(java.util.Collection<java.lang.String> items) {
    if (this.targets == null) {this.targets = new java.util.ArrayList<java.lang.String>();}
    for (java.lang.String item : items) {this.targets.add(item);} return (A)this;
  }
  public A removeFromTargets(java.lang.String... items) {
    for (java.lang.String item : items) {if (this.targets!= null){ this.targets.remove(item);}} return (A)this;
  }
  public A removeAllFromTargets(java.util.Collection<java.lang.String> items) {
    for (java.lang.String item : items) {if (this.targets!= null){ this.targets.remove(item);}} return (A)this;
  }
  public java.util.List<java.lang.String> getTargets() {
    return this.targets;
  }
  public java.lang.String getTarget(java.lang.Integer index) {
    return this.targets.get(index);
  }
  public java.lang.String getFirstTarget() {
    return this.targets.get(0);
  }
  public java.lang.String getLastTarget() {
    return this.targets.get(targets.size() - 1);
  }
  public java.lang.String getMatchingTarget(java.util.function.Predicate<java.lang.String> predicate) {
    for (java.lang.String item: targets) { if(predicate.test(item)){ return item;} } return null;
  }
  public java.lang.Boolean hasMatchingTarget(java.util.function.Predicate<java.lang.String> predicate) {
    for (java.lang.String item: targets) { if(predicate.test(item)){ return true;} } return false;
  }
  public A withTargets(java.util.List<java.lang.String> targets) {
    if (targets != null) {this.targets = new java.util.ArrayList<java.lang.String>(); for (java.lang.String item : targets){this.addToTargets(item);}} else { this.targets = null;} return (A) this;
  }
  public A withTargets(java.lang.String... targets) {
    if (this.targets != null) {this.targets.clear();}
    if (targets != null) {for (java.lang.String item :targets){ this.addToTargets(item);}} return (A) this;
  }
  public java.lang.Boolean hasTargets() {
    return targets != null && !targets.isEmpty();
  }
  public A addNewTarget(java.lang.String arg0) {
    return (A)addToTargets(new String(arg0));
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    DNSRecordSpecFluentImpl that = (DNSRecordSpecFluentImpl) o;
    if (dnsName != null ? !dnsName.equals(that.dnsName) :that.dnsName != null) return false;
    if (recordTTL != null ? !recordTTL.equals(that.recordTTL) :that.recordTTL != null) return false;
    if (recordType != null ? !recordType.equals(that.recordType) :that.recordType != null) return false;
    if (targets != null ? !targets.equals(that.targets) :that.targets != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(dnsName,  recordTTL,  recordType,  targets,  super.hashCode());
  }
  
}