package io.fabric8.openshift.api.model.operator.v1;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class ForwardPluginBuilder extends io.fabric8.openshift.api.model.operator.v1.ForwardPluginFluentImpl<io.fabric8.openshift.api.model.operator.v1.ForwardPluginBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.openshift.api.model.operator.v1.ForwardPlugin,io.fabric8.openshift.api.model.operator.v1.ForwardPluginBuilder>{
  public ForwardPluginBuilder() {
    this(false);
  }
  public ForwardPluginBuilder(java.lang.Boolean validationEnabled) {
    this(new ForwardPlugin(), validationEnabled);
  }
  public ForwardPluginBuilder(io.fabric8.openshift.api.model.operator.v1.ForwardPluginFluent<?> fluent) {
    this(fluent, false);
  }
  public ForwardPluginBuilder(io.fabric8.openshift.api.model.operator.v1.ForwardPluginFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new ForwardPlugin(), validationEnabled);
  }
  public ForwardPluginBuilder(io.fabric8.openshift.api.model.operator.v1.ForwardPluginFluent<?> fluent,io.fabric8.openshift.api.model.operator.v1.ForwardPlugin instance) {
    this(fluent, instance, false);
  }
  public ForwardPluginBuilder(io.fabric8.openshift.api.model.operator.v1.ForwardPluginFluent<?> fluent,io.fabric8.openshift.api.model.operator.v1.ForwardPlugin instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withUpstreams(instance.getUpstreams()); 
    this.validationEnabled = validationEnabled; 
  }
  public ForwardPluginBuilder(io.fabric8.openshift.api.model.operator.v1.ForwardPlugin instance) {
    this(instance,false);
  }
  public ForwardPluginBuilder(io.fabric8.openshift.api.model.operator.v1.ForwardPlugin instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withUpstreams(instance.getUpstreams()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.openshift.api.model.operator.v1.ForwardPluginFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.openshift.api.model.operator.v1.ForwardPlugin build() {
    ForwardPlugin buildable = new ForwardPlugin(fluent.getUpstreams());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    ForwardPluginBuilder that = (ForwardPluginBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}