package io.fabric8.openshift.api.model.operator.v1;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class ImagePrunerSpecBuilder extends io.fabric8.openshift.api.model.operator.v1.ImagePrunerSpecFluentImpl<io.fabric8.openshift.api.model.operator.v1.ImagePrunerSpecBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.openshift.api.model.operator.v1.ImagePrunerSpec,io.fabric8.openshift.api.model.operator.v1.ImagePrunerSpecBuilder>{
  public ImagePrunerSpecBuilder() {
    this(false);
  }
  public ImagePrunerSpecBuilder(java.lang.Boolean validationEnabled) {
    this(new ImagePrunerSpec(), validationEnabled);
  }
  public ImagePrunerSpecBuilder(io.fabric8.openshift.api.model.operator.v1.ImagePrunerSpecFluent<?> fluent) {
    this(fluent, false);
  }
  public ImagePrunerSpecBuilder(io.fabric8.openshift.api.model.operator.v1.ImagePrunerSpecFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new ImagePrunerSpec(), validationEnabled);
  }
  public ImagePrunerSpecBuilder(io.fabric8.openshift.api.model.operator.v1.ImagePrunerSpecFluent<?> fluent,io.fabric8.openshift.api.model.operator.v1.ImagePrunerSpec instance) {
    this(fluent, instance, false);
  }
  public ImagePrunerSpecBuilder(io.fabric8.openshift.api.model.operator.v1.ImagePrunerSpecFluent<?> fluent,io.fabric8.openshift.api.model.operator.v1.ImagePrunerSpec instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withAffinity(instance.getAffinity()); 
    fluent.withFailedJobsHistoryLimit(instance.getFailedJobsHistoryLimit()); 
    fluent.withIgnoreInvalidImageReferences(instance.getIgnoreInvalidImageReferences()); 
    fluent.withKeepTagRevisions(instance.getKeepTagRevisions()); 
    fluent.withKeepYoungerThan(instance.getKeepYoungerThan()); 
    fluent.withKeepYoungerThanDuration(instance.getKeepYoungerThanDuration()); 
    fluent.withLogLevel(instance.getLogLevel()); 
    fluent.withNodeSelector(instance.getNodeSelector()); 
    fluent.withResources(instance.getResources()); 
    fluent.withSchedule(instance.getSchedule()); 
    fluent.withSuccessfulJobsHistoryLimit(instance.getSuccessfulJobsHistoryLimit()); 
    fluent.withSuspend(instance.getSuspend()); 
    fluent.withTolerations(instance.getTolerations()); 
    this.validationEnabled = validationEnabled; 
  }
  public ImagePrunerSpecBuilder(io.fabric8.openshift.api.model.operator.v1.ImagePrunerSpec instance) {
    this(instance,false);
  }
  public ImagePrunerSpecBuilder(io.fabric8.openshift.api.model.operator.v1.ImagePrunerSpec instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withAffinity(instance.getAffinity()); 
    this.withFailedJobsHistoryLimit(instance.getFailedJobsHistoryLimit()); 
    this.withIgnoreInvalidImageReferences(instance.getIgnoreInvalidImageReferences()); 
    this.withKeepTagRevisions(instance.getKeepTagRevisions()); 
    this.withKeepYoungerThan(instance.getKeepYoungerThan()); 
    this.withKeepYoungerThanDuration(instance.getKeepYoungerThanDuration()); 
    this.withLogLevel(instance.getLogLevel()); 
    this.withNodeSelector(instance.getNodeSelector()); 
    this.withResources(instance.getResources()); 
    this.withSchedule(instance.getSchedule()); 
    this.withSuccessfulJobsHistoryLimit(instance.getSuccessfulJobsHistoryLimit()); 
    this.withSuspend(instance.getSuspend()); 
    this.withTolerations(instance.getTolerations()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.openshift.api.model.operator.v1.ImagePrunerSpecFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.openshift.api.model.operator.v1.ImagePrunerSpec build() {
    ImagePrunerSpec buildable = new ImagePrunerSpec(fluent.getAffinity(),fluent.getFailedJobsHistoryLimit(),fluent.getIgnoreInvalidImageReferences(),fluent.getKeepTagRevisions(),fluent.getKeepYoungerThan(),fluent.getKeepYoungerThanDuration(),fluent.getLogLevel(),fluent.getNodeSelector(),fluent.getResources(),fluent.getSchedule(),fluent.getSuccessfulJobsHistoryLimit(),fluent.getSuspend(),fluent.getTolerations());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    ImagePrunerSpecBuilder that = (ImagePrunerSpecBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}