package io.fabric8.openshift.api.model.operator.v1;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import io.fabric8.kubernetes.api.model.ResourceRequirementsBuilder;
import com.fasterxml.jackson.annotation.JsonInclude;
import io.fabric8.kubernetes.api.builder.Nested;
import java.util.ArrayList;
import java.lang.String;
import io.fabric8.kubernetes.api.model.ResourceRequirements;
import java.util.LinkedHashMap;
import java.util.function.Predicate;
import java.lang.Deprecated;
import io.fabric8.kubernetes.api.model.ResourceRequirementsFluent;
import java.util.List;
import java.lang.Boolean;
import io.fabric8.kubernetes.api.builder.Fluent;
import io.fabric8.kubernetes.api.model.Duration;
import java.lang.Integer;
import io.fabric8.kubernetes.api.model.Toleration;
import java.lang.Long;
import io.fabric8.kubernetes.api.model.Affinity;
import java.util.Collection;
import java.lang.Object;
import java.util.Map;

 /**
  * Generated
  */
public interface ImagePrunerSpecFluent<A extends io.fabric8.openshift.api.model.operator.v1.ImagePrunerSpecFluent<A>> extends io.fabric8.kubernetes.api.builder.Fluent<A>{
  public io.fabric8.kubernetes.api.model.Affinity getAffinity();
  public A withAffinity(io.fabric8.kubernetes.api.model.Affinity affinity);
  public java.lang.Boolean hasAffinity();
  public java.lang.Integer getFailedJobsHistoryLimit();
  public A withFailedJobsHistoryLimit(java.lang.Integer failedJobsHistoryLimit);
  public java.lang.Boolean hasFailedJobsHistoryLimit();
  public java.lang.Boolean getIgnoreInvalidImageReferences();
  public A withIgnoreInvalidImageReferences(java.lang.Boolean ignoreInvalidImageReferences);
  public java.lang.Boolean hasIgnoreInvalidImageReferences();
  public java.lang.Integer getKeepTagRevisions();
  public A withKeepTagRevisions(java.lang.Integer keepTagRevisions);
  public java.lang.Boolean hasKeepTagRevisions();
  public java.lang.Long getKeepYoungerThan();
  public A withKeepYoungerThan(java.lang.Long keepYoungerThan);
  public java.lang.Boolean hasKeepYoungerThan();
  public io.fabric8.kubernetes.api.model.Duration getKeepYoungerThanDuration();
  public A withKeepYoungerThanDuration(io.fabric8.kubernetes.api.model.Duration keepYoungerThanDuration);
  public java.lang.Boolean hasKeepYoungerThanDuration();
  public java.lang.String getLogLevel();
  public A withLogLevel(java.lang.String logLevel);
  public java.lang.Boolean hasLogLevel();
  
  /**
   * Method is deprecated. use withLogLevel instead.
   */
  @java.lang.Deprecated
  public A withNewLogLevel(java.lang.String arg0);
  public A addToNodeSelector(java.lang.String key,java.lang.String value);
  public A addToNodeSelector(java.util.Map<java.lang.String,java.lang.String> map);
  public A removeFromNodeSelector(java.lang.String key);
  public A removeFromNodeSelector(java.util.Map<java.lang.String,java.lang.String> map);
  public java.util.Map<java.lang.String,java.lang.String> getNodeSelector();
  public <K,V>A withNodeSelector(java.util.Map<java.lang.String,java.lang.String> nodeSelector);
  public java.lang.Boolean hasNodeSelector();
  
  /**
   * This method has been deprecated, please use method buildResources instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.ResourceRequirements getResources();
  public io.fabric8.kubernetes.api.model.ResourceRequirements buildResources();
  public A withResources(io.fabric8.kubernetes.api.model.ResourceRequirements resources);
  public java.lang.Boolean hasResources();
  public io.fabric8.openshift.api.model.operator.v1.ImagePrunerSpecFluent.ResourcesNested<A> withNewResources();
  public io.fabric8.openshift.api.model.operator.v1.ImagePrunerSpecFluent.ResourcesNested<A> withNewResourcesLike(io.fabric8.kubernetes.api.model.ResourceRequirements item);
  public io.fabric8.openshift.api.model.operator.v1.ImagePrunerSpecFluent.ResourcesNested<A> editResources();
  public io.fabric8.openshift.api.model.operator.v1.ImagePrunerSpecFluent.ResourcesNested<A> editOrNewResources();
  public io.fabric8.openshift.api.model.operator.v1.ImagePrunerSpecFluent.ResourcesNested<A> editOrNewResourcesLike(io.fabric8.kubernetes.api.model.ResourceRequirements item);
  public java.lang.String getSchedule();
  public A withSchedule(java.lang.String schedule);
  public java.lang.Boolean hasSchedule();
  
  /**
   * Method is deprecated. use withSchedule instead.
   */
  @java.lang.Deprecated
  public A withNewSchedule(java.lang.String arg0);
  public java.lang.Integer getSuccessfulJobsHistoryLimit();
  public A withSuccessfulJobsHistoryLimit(java.lang.Integer successfulJobsHistoryLimit);
  public java.lang.Boolean hasSuccessfulJobsHistoryLimit();
  public java.lang.Boolean getSuspend();
  public A withSuspend(java.lang.Boolean suspend);
  public java.lang.Boolean hasSuspend();
  public A addToTolerations(java.lang.Integer index,io.fabric8.kubernetes.api.model.Toleration item);
  public A setToTolerations(java.lang.Integer index,io.fabric8.kubernetes.api.model.Toleration item);
  public A addToTolerations(io.fabric8.kubernetes.api.model.Toleration... items);
  public A addAllToTolerations(java.util.Collection<io.fabric8.kubernetes.api.model.Toleration> items);
  public A removeFromTolerations(io.fabric8.kubernetes.api.model.Toleration... items);
  public A removeAllFromTolerations(java.util.Collection<io.fabric8.kubernetes.api.model.Toleration> items);
  public java.util.List<io.fabric8.kubernetes.api.model.Toleration> getTolerations();
  public io.fabric8.kubernetes.api.model.Toleration getToleration(java.lang.Integer index);
  public io.fabric8.kubernetes.api.model.Toleration getFirstToleration();
  public io.fabric8.kubernetes.api.model.Toleration getLastToleration();
  public io.fabric8.kubernetes.api.model.Toleration getMatchingToleration(java.util.function.Predicate<io.fabric8.kubernetes.api.model.Toleration> predicate);
  public java.lang.Boolean hasMatchingToleration(java.util.function.Predicate<io.fabric8.kubernetes.api.model.Toleration> predicate);
  public A withTolerations(java.util.List<io.fabric8.kubernetes.api.model.Toleration> tolerations);
  public A withTolerations(io.fabric8.kubernetes.api.model.Toleration... tolerations);
  public java.lang.Boolean hasTolerations();
  public A addNewToleration(java.lang.String effect,java.lang.String key,java.lang.String operator,java.lang.Long tolerationSeconds,java.lang.String value);
  public interface ResourcesNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.ResourceRequirementsFluent<io.fabric8.openshift.api.model.operator.v1.ImagePrunerSpecFluent.ResourcesNested<N>>{
    public N and();
    public N endResources();
    
  }
  
}