package io.fabric8.openshift.api.model.operator.v1;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class LoggingDestinationBuilder extends io.fabric8.openshift.api.model.operator.v1.LoggingDestinationFluentImpl<io.fabric8.openshift.api.model.operator.v1.LoggingDestinationBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.openshift.api.model.operator.v1.LoggingDestination,io.fabric8.openshift.api.model.operator.v1.LoggingDestinationBuilder>{
  public LoggingDestinationBuilder() {
    this(false);
  }
  public LoggingDestinationBuilder(java.lang.Boolean validationEnabled) {
    this(new LoggingDestination(), validationEnabled);
  }
  public LoggingDestinationBuilder(io.fabric8.openshift.api.model.operator.v1.LoggingDestinationFluent<?> fluent) {
    this(fluent, false);
  }
  public LoggingDestinationBuilder(io.fabric8.openshift.api.model.operator.v1.LoggingDestinationFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new LoggingDestination(), validationEnabled);
  }
  public LoggingDestinationBuilder(io.fabric8.openshift.api.model.operator.v1.LoggingDestinationFluent<?> fluent,io.fabric8.openshift.api.model.operator.v1.LoggingDestination instance) {
    this(fluent, instance, false);
  }
  public LoggingDestinationBuilder(io.fabric8.openshift.api.model.operator.v1.LoggingDestinationFluent<?> fluent,io.fabric8.openshift.api.model.operator.v1.LoggingDestination instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withContainer(instance.getContainer()); 
    fluent.withSyslog(instance.getSyslog()); 
    fluent.withType(instance.getType()); 
    this.validationEnabled = validationEnabled; 
  }
  public LoggingDestinationBuilder(io.fabric8.openshift.api.model.operator.v1.LoggingDestination instance) {
    this(instance,false);
  }
  public LoggingDestinationBuilder(io.fabric8.openshift.api.model.operator.v1.LoggingDestination instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withContainer(instance.getContainer()); 
    this.withSyslog(instance.getSyslog()); 
    this.withType(instance.getType()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.openshift.api.model.operator.v1.LoggingDestinationFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.openshift.api.model.operator.v1.LoggingDestination build() {
    LoggingDestination buildable = new LoggingDestination(fluent.getContainer(),fluent.getSyslog(),fluent.getType());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    LoggingDestinationBuilder that = (LoggingDestinationBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}