package io.fabric8.openshift.api.model.operator.v1alpha1;

import java.util.ArrayList;
import java.lang.String;
import java.util.function.Predicate;
import java.lang.Integer;
import java.lang.Deprecated;
import io.fabric8.kubernetes.api.builder.BaseFluent;
import java.util.Collection;
import java.lang.Object;
import java.util.List;
import java.lang.Boolean;

 /**
  * Generated
  */
public class RepositoryDigestMirrorsFluentImpl<A extends io.fabric8.openshift.api.model.operator.v1alpha1.RepositoryDigestMirrorsFluent<A>> extends io.fabric8.kubernetes.api.builder.BaseFluent<A> implements io.fabric8.openshift.api.model.operator.v1alpha1.RepositoryDigestMirrorsFluent<A>{
  public RepositoryDigestMirrorsFluentImpl() {
  }
  public RepositoryDigestMirrorsFluentImpl(io.fabric8.openshift.api.model.operator.v1alpha1.RepositoryDigestMirrors instance) {
    this.withMirrors(instance.getMirrors()); 
    this.withSource(instance.getSource()); 
  }
  private java.util.List<java.lang.String> mirrors = new java.util.ArrayList<java.lang.String>();
  private java.lang.String source;
  public A addToMirrors(java.lang.Integer index,java.lang.String item) {
    if (this.mirrors == null) {this.mirrors = new java.util.ArrayList<java.lang.String>();}
    this.mirrors.add(index, item);
    return (A)this;
  }
  public A setToMirrors(java.lang.Integer index,java.lang.String item) {
    if (this.mirrors == null) {this.mirrors = new java.util.ArrayList<java.lang.String>();}
    this.mirrors.set(index, item); return (A)this;
  }
  public A addToMirrors(java.lang.String... items) {
    if (this.mirrors == null) {this.mirrors = new java.util.ArrayList<java.lang.String>();}
    for (java.lang.String item : items) {this.mirrors.add(item);} return (A)this;
  }
  public A addAllToMirrors(java.util.Collection<java.lang.String> items) {
    if (this.mirrors == null) {this.mirrors = new java.util.ArrayList<java.lang.String>();}
    for (java.lang.String item : items) {this.mirrors.add(item);} return (A)this;
  }
  public A removeFromMirrors(java.lang.String... items) {
    for (java.lang.String item : items) {if (this.mirrors!= null){ this.mirrors.remove(item);}} return (A)this;
  }
  public A removeAllFromMirrors(java.util.Collection<java.lang.String> items) {
    for (java.lang.String item : items) {if (this.mirrors!= null){ this.mirrors.remove(item);}} return (A)this;
  }
  public java.util.List<java.lang.String> getMirrors() {
    return this.mirrors;
  }
  public java.lang.String getMirror(java.lang.Integer index) {
    return this.mirrors.get(index);
  }
  public java.lang.String getFirstMirror() {
    return this.mirrors.get(0);
  }
  public java.lang.String getLastMirror() {
    return this.mirrors.get(mirrors.size() - 1);
  }
  public java.lang.String getMatchingMirror(java.util.function.Predicate<java.lang.String> predicate) {
    for (java.lang.String item: mirrors) { if(predicate.test(item)){ return item;} } return null;
  }
  public java.lang.Boolean hasMatchingMirror(java.util.function.Predicate<java.lang.String> predicate) {
    for (java.lang.String item: mirrors) { if(predicate.test(item)){ return true;} } return false;
  }
  public A withMirrors(java.util.List<java.lang.String> mirrors) {
    if (mirrors != null) {this.mirrors = new java.util.ArrayList<java.lang.String>(); for (java.lang.String item : mirrors){this.addToMirrors(item);}} else { this.mirrors = null;} return (A) this;
  }
  public A withMirrors(java.lang.String... mirrors) {
    if (this.mirrors != null) {this.mirrors.clear();}
    if (mirrors != null) {for (java.lang.String item :mirrors){ this.addToMirrors(item);}} return (A) this;
  }
  public java.lang.Boolean hasMirrors() {
    return mirrors != null && !mirrors.isEmpty();
  }
  public A addNewMirror(java.lang.String arg0) {
    return (A)addToMirrors(new String(arg0));
  }
  public java.lang.String getSource() {
    return this.source;
  }
  public A withSource(java.lang.String source) {
    this.source=source; return (A) this;
  }
  public java.lang.Boolean hasSource() {
    return this.source != null;
  }
  
  /**
   * Method is deprecated. use withSource instead.
   */
  @java.lang.Deprecated
  public A withNewSource(java.lang.String arg0) {
    return (A)withSource(new String(arg0));
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    RepositoryDigestMirrorsFluentImpl that = (RepositoryDigestMirrorsFluentImpl) o;
    if (mirrors != null ? !mirrors.equals(that.mirrors) :that.mirrors != null) return false;
    if (source != null ? !source.equals(that.source) :that.source != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(mirrors,  source,  super.hashCode());
  }
  
}